Con                            's2 motor driver 'ratronic' Dave Ratcliff 1/24/14 - this is modified from kye's pwm2c_hbdengine
                               
Var                            'variables

  long cogNumber, frequencyNumber, leftChannelDuty, rightChannelDuty
  long cycleFrequency, Stack[10]
  
Pub Start(PWM_Freq)            'start S2 motor driver @ PWM_Freq hertz
  
  cycleFrequency := PWM_Freq
  return cogNumber := cognew(HBDDriver, @stack) 
          
Pub Stop                       'stop S2 motor driver cog

  if cogNumber
    cogstop(cogNumber)
      
Pub LeftRightDuty(left, right) 'sets the pwm amount-- -400 = %100 full reverse to 400 = %100 full forward

  left := -400 #> left <# 400  
  right := -400 #> right <# 400
  
  leftChannelDuty := left
  rightChannelDuty := right
  
Pri HBDDriver                  'S2 motor driver
                                                                                                                 
  frequencyNumber := (clkfreq / ((cycleFrequency <# (clkfreq / constant(80_000_000 / 8_000))) #> 1))           
  dira := $f0000 's2 motor cntrl pins P16..P19 set to output                                                          
  frqa := 1                                                                     
  frqb := 1                                                                     
  result := cnt                                                                 
                                                                                
  repeat                                                                        
    result += frequencyNumber                                                   
    waitcnt(result)
    if leftChannelDuty < 0
      outa[16]~
    else
      outa[16]~~
    if rightChannelDuty < 0
      outa[17]~
    else
      outa[17]~~
                                                                         
    phsa := -((||leftChannelDuty) * (frequencyNumber / 400))                  
    phsb := -((||rightChannelDuty) * (frequencyNumber / 400))                 
    ctra := constant(%0_0100 << 26) | 18 
    ctrb := constant(%0_0100 << 26) | 19